package edu.ucla.ccb.graphshifts.data;

import java.io.Serializable;


/**
 * DataItem is the highest level encapsulation of any piece of data that 
 *  is processed through my code.
 * 
 * Basically, it is an empty class.
 * @author jcorso
 *
 */
abstract public class DataItem implements Serializable 
{
	public DataItem()
	{
		
	}
	
	/**
	 * Should be over-ridden to return the actual data associated
	 *  with this item.
	 * @return
	 */
	abstract public Object getData();
}
